/*******************************************************************************
 Programm zur Ausgabe des Zeichensatzes in einem LCD 
 Zur vollstandigen Ausgabe mit Adressen ist ein 24-stelliges LCD notwendig 
 Fr LCD mit weniger Zeichen kann die Adressausgabe weggelassen werden 
 Autor: Hubert Gschwandtner  www.hubert t schorsch.at
********************************************************************************/


#include <avr/io.h>
#include "lcd_new.h"
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <stdlib.h>
 char Programmname[]PROGMEM="ROM-Codetest";
 char Versionsnummer[]PROGMEM=" LCD";

#define lcd_24  0  // 1= LCD mit 24 Zeichen  0= LCD mit weniger als 24 Zeichen

int main(void)
{
DDRB=0x00;
PORTB=(1<<PB2);				//Taste fr weiterschaltung

lcd_init(LCD_DISP_ON);
lcd_puts_p(Versionsnummer);
lcd_gotoxy(0,1);
lcd_puts_p(Programmname);

_delay_ms(500);
 int i=0x00;				//Zeilen Startadresse
 int e=0x0f;				//Zeilen Endadresse
 int z;
 

lcd_gotoxy(0,0);
for(;;){
lcd_clrscr();

for (z=i; z<=e; z++){		//Schleife erste Zeile

lcd_putc(z);				//Ausgabe des Charakter aus ROM
}
#if lcd_24
char buffer[4];
char zeichenl;
lcd_gotoxy(17,0);			
itoa(i,buffer,10);			//Ausgabe der Zeilenstartadresse
zeichenl=(strlen(buffer));
if(zeichenl==1){
	lcd_putc(32);
	lcd_putc(32);
	lcd_putc(48);
	}
else if(zeichenl==2){
	lcd_putc(32);
	lcd_putc(buffer[0]);
	lcd_putc(buffer[1]);
	}
	else{
lcd_putc(buffer[0]);
lcd_putc(buffer[1]);
lcd_putc(buffer[2]);
}
lcd_putc(0x5f);
itoa(e,buffer,10);			// Ausgabe der Zeilenendadresse
zeichenl=(strlen(buffer));
if(zeichenl==2){
	lcd_putc(32);
	lcd_putc(buffer[0]);
	lcd_putc(buffer[1]);
	}
	else{
lcd_putc(buffer[0]);
lcd_putc(buffer[1]);
lcd_putc(buffer[2]);
}
#endif
lcd_gotoxy(0,1);			// Zweite Zeile
i=i+0x10;					// Startadresse zweite Zeile
e=e+0x10;					// Endadresse zweite Zeile

for (z=i; z<=e; z++){		// Schleife zweite Zeile

lcd_putc(z);				//Ausgabe des Charakter aus ROM

}
#if lcd_24
lcd_gotoxy(17,1);
itoa(i,buffer,10);			//Ausgabe der Zeilenstartadresse
zeichenl=(strlen(buffer));
if(zeichenl==2){
	lcd_putc(32);
	lcd_putc(buffer[0]);
	lcd_putc(buffer[1]);
	}
	else{
lcd_putc(buffer[0]);
lcd_putc(buffer[1]);
lcd_putc(buffer[2]);
}
lcd_putc(0x5f);
itoa(e,buffer,10);			// Ausgabe der Zeilenendadresse
zeichenl=(strlen(buffer));
if(zeichenl==2){
	lcd_putc(32);
	lcd_putc(buffer[0]);
	lcd_putc(buffer[1]);
	}
	else{
lcd_putc(buffer[0]);
lcd_putc(buffer[1]);
lcd_putc(buffer[2]);
}
#endif

i=i+0x10;					// Startadresse nchste Zeile
e=e+0x10;					// Endadresse nchste Zeile
_delay_ms(500);

while(PINB & (1<<PINB2));	// Warten auf Tastendruck zur Weiterschaltung
_delay_ms(500);
if(i>=0xff){				// Wenn Adresse ff erreicht dann zurck zum Anfang
	i=0x00;
	e=0x0f;
	}
}
}
